package ptglob

func Match(pattern, text string) bool {
	m, _ := MatchParts(pattern, text)
	return m
}

func MatchParts(pattern, text string) (bool, []string) {
	matches := make([]string, 0)
	if pattern == "" {
		if text == "" {
			return true, matches
		}
		return false, make([]string, 0)
	}
	if pattern == "*" {
		return true, []string{text}
	}
	txtpos := 0
	patpos := 0
	txtlen := len(text)
	patlen := len(pattern)
	cp := -1
	mp := -1
	for (txtpos < txtlen) && (patpos < patlen) && (pattern[patpos] != '*') {
		if text[txtpos] != pattern[patpos] {
			if pattern[patpos] != '?' {
				return false, make([]string, 0)
			}
			matches = append(matches, text[txtpos:txtpos+1])
		}
		txtpos++
		patpos++
	}
	if patpos == patlen {
		if pattern == text {
			return true, []string{text}
		}
		return false, []string{}
	}
	cur := ""
	for txtpos < txtlen {
		if (patpos < patlen) && (pattern[patpos] == '*') {
			if len(cur) > 0 {
				matches = append(matches, cur)
				cur = ""
			}
			patpos++
			if patpos >= patlen {
				if txtpos < txtlen {
					matches = append(matches, text[txtpos:txtlen])
				}
				return true, matches
			}
			mp = patpos
			cp = txtpos + 1
		} else if (patpos < patlen) && ((text[txtpos] == pattern[patpos]) || (pattern[patpos] == '?')) {
			if len(cur) > 0 {
				matches = append(matches, cur)
				cur = ""
			}
			if text[txtpos] != pattern[patpos] {
				matches = append(matches, text[txtpos:txtpos+1])
			}
			patpos++
			txtpos++
		} else {
			cur = cur + text[txtpos:txtpos+1]
			patpos = mp
			txtpos = cp
			cp++
		}
	}
	if len(cur) > 0 {
		matches = append(matches, cur)
		cur = ""
	}
	if patpos < patlen {
		return false, make([]string, 0)
	}
	return true, matches
}

func Rewrite(pattern, text, rewrite string) (bool, string) {
	ok, m := MatchParts(pattern, text)
	if !ok {
		return false, ""
	}
	r := ""
	l := len(rewrite)
	for p := 0; p < l; p++ {
		c := rewrite[p]
		if c == '%' {
			p++
			if p < l {
				c = rewrite[p]
				if c == '%' {
					r = r + "%"
				} else {
					idx := int(c - '1')
					if idx >= 0 && idx < len(m) {
						r = r + m[idx]
					}
				}
			}
		} else {
			r = r + string(c)
		}
	}

	return true, r
}
